/**
 * SubstringFilter.java
 *
 * File generated from the core::SubstringFilter uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class SubstringFilter.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "SubstringFilter", propOrder = {
	"initial",
	"any",
	"_final",
	"name"
})
@XmlRootElement(name = "SubstringFilter")
public class SubstringFilter extends net.ihe.gazelle.gen.common.CommonOperations implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "initial", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public String initial;
	@XmlElement(name = "any", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public List<String> any;
	@XmlElement(name = "final", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public String _final;
	@XmlAttribute(name = "name", required = true)
	public String name;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return initial.
	 * @return initial
	 */
	public String getInitial() {
	    return initial;
	}
	
	/**
	 * Set a value to attribute initial.
	 * @param initial.
	 */
	public void setInitial(String initial) {
	    this.initial = initial;
	}
	
	
	
	
	/**
	 * Return any.
	 * @return any
	 */
	public List<String> getAny() {
		if (any == null) {
	        any = new ArrayList<String>();
	    }
	    return any;
	}
	
	/**
	 * Set a value to attribute any.
	 * @param any.
	 */
	public void setAny(List<String> any) {
	    this.any = any;
	}
	
	
	
	/**
	 * Add a any to the any collection.
	 * @param any_elt Element to add.
	 */
	public void addAny(String any_elt) {
	    this.getAny().add(any_elt);
	}
	
	/**
	 * Remove a any to the any collection.
	 * @param any_elt Element to remove
	 */
	public void removeAny(String any_elt) {
	    this.getAny().remove(any_elt);
	}
	
	/**
	 * Return _final.
	 * @return _final
	 */
	public String get_final() {
	    return _final;
	}
	
	/**
	 * Set a value to attribute _final.
	 * @param _final.
	 */
	public void set_final(String _final) {
	    this._final = _final;
	}
	
	
	
	
	/**
	 * Return name.
	 * @return name
	 */
	public String getName() {
	    return name;
	}
	
	/**
	 * Set a value to attribute name.
	 * @param name.
	 */
	public void setName(String name) {
	    this.name = name;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "SubstringFilter").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(SubstringFilter substringFilter, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (substringFilter != null){
   			cvm.validate(substringFilter, _location, diagnostic);
    	}
    }

}